--dofile("mods/ArenaForMonster/scripts/load_monster_list.lua")nto
dofile_once("data/scripts/lib/utilities.lua")
local x = 0
local y = 0
local camera_move_scale = 28


--overall_biome_data = dofile("mods/ArenaForMonster/scripts/load_monster_list.lua")
dofile_once("mods/ArenaForMonster/scripts/main_gui.lua")
function OnWorldPreUpdate()
    local player_id = EntityGetWithTag("player_unit")[1]
    if player_id ~= nil then
        local fire_enable = (GlobalsGetValue("FIRE_ENABLE","false") == "true")
        if fire_enable then
            local inventory_gui_comp = EntityGetFirstComponentIncludingDisabled(player_id ,"InventoryGuiComponent")
            if inventory_gui_comp ~= nil then
                EntitySetComponentIsEnabled(player_id,inventory_gui_comp,true)
            end
        else
            --disable ui
            local inventory_gui_comp = EntityGetFirstComponentIncludingDisabled(player_id ,"InventoryGuiComponent")
            if inventory_gui_comp ~= nil then
                EntitySetComponentIsEnabled(player_id,inventory_gui_comp,false)
            end

            --disable wand
            local inventory = EntityGetWithName("inventory_quick")
            local items = EntityGetAllChildren(inventory)
            if items ~= nil then
                for _,item in pairs(items) do
                    --disable mana
                    local ability_comp = EntityGetFirstComponentIncludingDisabled(item ,"AbilityComponent")
                    if ability_comp ~= nil then
                        ComponentSetValue2(ability_comp,"mana",-100)
                    end
                    local children = EntityGetAllChildren(item)
                    if children ~= nil then
                        local spells = {}
                        local spell_storage = nil
                        for _,child_entity in pairs(children) do
                            if EntityGetName(child_entity) == "spell_storge" then
                                --is storge
                                spell_storage = child_entity
                            elseif EntityGetFirstComponentIncludingDisabled(child_entity,"ItemActionComponent") ~= nil then
                                --is a spell
                                table.insert(spells,child_entity)
                            end
        
                            if #spells ~= 0 then
                                if spell_storage == nil then
                                    spell_storage = EntityLoad("mods/ArenaForMonster/entities/spell_storge.xml")
                                    print("load a storge entity")
                                    EntityAddChild(item,spell_storage)
                                end
                                for _,spell in pairs(spells) do
                                    EntityRemoveFromParent(spell)
                                    EntityAddChild(spell_storage,spell)
                                end
    
                                local inventory2comp = EntityGetFirstComponentIncludingDisabled(player_id ,"Inventory2Component")
                                if inventory2comp ~= nil then
                                    ComponentSetValue2(inventory2comp,"mActiveItem",0)
                                end
    
    
                            end
                        end
                    end
                end
            end

        end
    end
end

function OnWorldPostUpdate()
    --[[
    local player = EntityGetWithTag("player_unit")[1]
    if player == nil then return end
    local control_comp = EntityGetFirstComponentIncludingDisabled(player,"ControlsComponent")
    local up_pressed,down_pressed,left_pressed,right_pressed;
    if control_comp ~= nil then
        edit_component2(player,"ControlsComponent",function (comp,vars)
            --mouse_x,mouse_y = ComponentGetValue2( comp, "mMousePosition")
            up_pressed = ComponentGetValue2( comp, "mButtonDownUp")
            down_pressed = ComponentGetValue2( comp, "mButtonDownDown")
            left_pressed = ComponentGetValue2( comp, "mButtonDownLeft")
            right_pressed = ComponentGetValue2( comp, "mButtonDownRight")
        end )
    end

    local x,y = EntityGetTransform(player)
    if x ~= nil then
        if up_pressed then
            y = y-camera_move_scale
        elseif down_pressed then
            y = y +camera_move_scale
        end
        if left_pressed then
            x = x - camera_move_scale
        elseif right_pressed then
            x = x + camera_move_scale
        end
        EntitySetTransform(player,x,y)
    end
]]
    if _monster_arena_update_main ~= nil then
        _monster_arena_update_main()
    end
end

function OnPlayerSpawned( player_entity ) -- this runs when player entity has been created
    GlobalsSetValue("FIRE_ENABLE",tostring(false))
    local gene_comps = EntityGetComponentIncludingDisabled(player_entity,"GenomeDataComponent")
    for _,comp in pairs(gene_comps) do
        ComponentSetValue2(comp,"herd_id",StringToHerdId("curse" ) )
    end 

    local damage_comp = EntityGetFirstComponentIncludingDisabled(player_entity,"DamageModelComponent")
    if damage_comp ~= nil then
        EntitySetComponentIsEnabled(player_entity,damage_comp,false)
    end

    if arena_list ~= nil then
        for _,arena_info in pairs(arena_list) do
            EntityLoad(arena_info.file,arena_info.x,arena_info.y)
        end
    else
        print("no arena list, arena not spawned at player spawned.")
    end
   
    --EntityAddChild(EntityGetWithName("inventory_quick"),empty_wand)

--[[
    player = player_entity
    x,y = EntityGetTransform(player_entity)
    --EntityLoad("data/entities/animals/healderdrone_physics.xml",x,y)
    --disable players move and other interact
    local inventory
    local player_arm
    local player_child_entities = EntityGetAllChildren( player_entity )
    if ( player_child_entities ~= nil ) then
        for i,child_entity in ipairs( player_child_entities ) do
            local child_entity_name = EntityGetName( child_entity )

            if ( child_entity_name == "inventory_quick" ) then
                inventory = child_entity
            elseif ( child_entity_name == "cape" ) then
                EntityKill(child_entity)
            elseif ( child_entity_name == "arm_r" ) then
                player_arm = child_entity
                -- disable sprite
                local sprite_comps = EntityGetComponentIncludingDisabled(player_arm ,"SpriteComponent")
                for _,comp in pairs(sprite_comps) do
                    EntitySetComponentIsEnabled(player_arm ,comp,false)
                end
            else
                EntityKill(child_entity)
            end
        end
    end

    if inventory ~= nil then
        local inventory_items = EntityGetAllChildren( inventory )
        -- remove default items
        if inventory_items ~= nil then
            for i,item_entity in ipairs( inventory_items ) do
                GameKillInventoryItem( player_entity, item_entity )
            end
        end
    end

    local move_member = {"jump_velocity_x","jump_velocity_y","velocity_max_x","run_velocity","pixel_gravity"}
    local models = EntityGetComponentIncludingDisabled( player_entity, "CharacterPlatformingComponent" )
    if( models ~= nil ) then
        for i,model in ipairs(models) do
            for _,member in pairs(move_member) do
                ComponentSetValue2( model, member, 0)
            end
        end
    end

    local platformingcomponent = EntityGetFirstComponentIncludingDisabled( player_entity, "CharacterDataComponent" )
    ComponentSetValue2( platformingcomponent, "mFlyingTimeLeft", 0 )
    ComponentSetValue2( platformingcomponent, "fly_time_max", 0 )

    -- disable sprite
    local sprite_comps = EntityGetComponentIncludingDisabled(player_entity,"SpriteComponent")
    for _,comp in pairs(sprite_comps) do
        EntitySetComponentIsEnabled(player_entity,comp,false)
    end

    -- disable damage model
    local damage_comps = EntityGetComponentIncludingDisabled(player_entity,"DamageModelComponent")
    for _,comp in pairs(damage_comps) do
        EntitySetComponentIsEnabled(player_entity,comp,false)
    end
    ]]--

end

local translation = ModTextFileGetContent("data/translations/common.csv") .. ModTextFileGetContent("mods/ArenaForMonster/translation/common.csv")
ModTextFileSetContent("data/translations/common.csv", translation)

local patch_text = [[

        local old = EntityLoad
        local function EntityLoad(filename, pos_x, pos_y)
            local monster_id = old(filename, pos_x, pos_y)
            if monster_id == nil then
                return
            end
            local herd_entity = GetUpdatedEntityID()
            local gene_comp = EntityGetFirstComponentIncludingDisabled(herd_entity,"GenomeDataComponent")
            if gene_comp == nil then
                print("no GenomeDataComponent on parent!")
                return monster_id
            end
            local herd_id = ComponentGetValue2(gene_comp,"herd_id")

			local scripts_entity = old("mods/ArenaForMonster/entities/effect_entity/change_herd_id.xml",pos_x,pos_y)
			local var_comp = EntityGetFirstComponentIncludingDisabled(scripts_entity,"VariableStorageComponent")
			ComponentSetValue2(var_comp,"value_int",herd_id)
			EntityAddChild(monster_id,scripts_entity)

            local gene_comps = EntityGetComponentIncludingDisabled(monster_id,"GenomeDataComponent")
            if gene_comps == nil then
                print("no GenomeDataComponent on child!")
                return
            end
        
            for _,comp in pairs(gene_comps) do
                ComponentSetValue2(comp,"herd_id",herd_id)
            end
       
            
            EntityLoadToEntity("mods/ArenaForMonster/entities/hp_bar.xml", monster_id )
            local parent_hp_bar_comp = EntityGetFirstComponentIncludingDisabled(herd_entity,"SpriteComponent","hp_bar")
            local hp_bar_sprite = ComponentGetValue2(parent_hp_bar_comp,"image_file")
            local monster_hp_bar_comp = EntityGetFirstComponentIncludingDisabled(monster_id,"SpriteComponent","hp_bar")
            ComponentSetValue2(monster_hp_bar_comp,"image_file",hp_bar_sprite)

            return monster_id
        end

]]



local head_length = string.len([[dofile_once("data/scripts/lib/utilities.lua")

function damage_received( damage, desc, entity_who_caused, is_fatal )]]) + 1

local patch_scripts_list = {
    "data/scripts/animals/bigzombie_death.lua",
    "data/scripts/animals/blob_damage.lua",
    "data/scripts/animals/giantshooter_death.lua",
    "data/scripts/animals/leader_damage.lua",
}
--print(ModTextFileGetContent("data/scripts/animals/blob_damage.lua"))
for _,script_file in pairs(patch_scripts_list) do 
    local text = ModTextFileGetContent(script_file)
    --text = string.sub(text,head_length,string.len(text))
    text = patch_text..text
    --print(text)
    ModTextFileSetContent(script_file,text)
end
--print(ModTextFileGetContent("data/scripts/animals/blob_damage.lua"))
--ModLuaFileAppend( "data/scripts/gun/gun_actions.lua", "mods/ArenaForMonster/scripts/action_modify.lua" )

local replace_file_list = {
    ["data/scripts/status_effects/necrobot_super_end.lua"] = "mods/ArenaForMonster/scripts/patch/entities/necrobot_super_end.lua",
    ["data/scripts/status_effects/necrobot_end.lua"] = "mods/ArenaForMonster/scripts/patch/entities/necrobot_end.lua",
    ["data/scripts/animals/necrobot.lua"] = "mods/ArenaForMonster/scripts/patch/animals/necrobot/necrobot.lua",
    ["data/scripts/animals/necrobot_super.lua"] = "mods/ArenaForMonster/scripts/patch/animals/necrobot/necrobot_super.lua"
}
for replace_file,lua_file in pairs(replace_file_list) do
    ModTextFileSetContent(replace_file,ModTextFileGetContent(lua_file))
end