local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local _,min_x,max_y = Raytrace( x, y, x-175, y+75 )
local _,max_x,min_y = Raytrace( x, y,x+175, y-75 )

local segments = math.floor((max_x-min_x)/7) 
local segments_width = 7
local segments_height = 3
local prev_body = 0
local pos_x =  min_x - x +2 +1.75
local pos_y =  max_y - y +2 +0.75

for i =1,segments do
    local body = PhysicsAddBodyImage(entity_id, "mods/ArenaForMonster/arena_scene/bridge_2.png","wood_prop", pos_x, pos_y)
    if prev_body == 0 then
        PhysicsAddJoint( entity_id, -1, body, pos_x, pos_y, "REVOLUTE_JOINT", false )	
    else
        PhysicsAddJoint( entity_id, prev_body, body, pos_x, pos_y, "REVOLUTE_JOINT", false )
    end
    pos_x = pos_x + segments_width
    pos_y = pos_y - segments_height
	prev_body = body
end
PhysicsAddJoint( entity_id, prev_body, -1, pos_x, pos_y, "REVOLUTE_JOINT", false )	
--[[

min_x = x - min_x
max_x = max_x - x
local pos_x0 = -(min_x) + 3
local pos_x1 = max_x - 5

local bridge_width = pos_x1 - pos_x0
local segments = 6
local overlap = 7
local width = (bridge_width / segments)
local height = 5

local pos_x = pos_x0 + (overlap/2)
local pos_y = 0
local prev_body = 0
local joint_pos_x = pos_x + (overlap/2)
local joint_pos_y = pos_y + (height/2)

for i=1,segments do
	--print( pos_x - (overlap/2) )
	--print( pos_y )
    	local body = PhysicsAddBodyCreateBox( entity_id, "wood_prop", pos_x - (overlap/2), pos_y, width + overlap, height )
	if( prev_body == 0 ) then
		PhysicsAddJoint( entity_id, -1, body, joint_pos_x, joint_pos_y, "REVOLUTE_JOINT", false )			
	else
		PhysicsAddJoint( entity_id, prev_body, body, joint_pos_x, joint_pos_y, "REVOLUTE_JOINT", false )			
	end
	pos_x = pos_x + width
	joint_pos_x = joint_pos_x + width
	prev_body = body
end
			

]]