TRIBES = {rat=1,hiis =2 }


local trees = {
    "data/entities/vegetation/tree_spruce_1.xml",
    "data/entities/vegetation/tree_spruce_2.xml",
    "data/entities/vegetation/tree_spruce_3.xml",
    "data/entities/vegetation/tree_spruce_4.xml",
    "data/entities/vegetation/tree_spruce_5.xml",
}


function load_random_tree(x_pos,y_pos)
    local x = x_pos + (Random(-100,100)/4)
    local did_hit,hit_x,hit_y = RaytracePlatforms( x, y_pos, x, y_pos+250 )
    if did_hit ~= true then
        print("can't create tree at:"..tostring(x)..","..tostring(y_pos))
        EntityLoad(trees[Random(1,#trees)],x_pos,y_pos)
        return
    end
    EntityLoad(trees[Random(1,#trees)],hit_x,hit_y + 15)
end

function load_monster_preview(monster_data,tribes)
    if monster_data == nil then
        print("try to load a empty monster data!")
        return
    end

    local monster_tribes = tribes
    if tribes == nil then
        monster_tribes = TRIBES.rat
    end
    local sprite = monster_data.sprite.filepath
    if sprite == nil then
        --TODO:add a default picture of none sprite
        sprite = "data/entities/projectiles/bomb.xml"
    end
    local offset_x = monster_data.sprite.offset_x or 0
    local offset_y = monster_data.sprite.offset_y or 0
    local x,y = DEBUG_GetMouseWorld() 
    local preview_enity = EntityLoad("mods/ArenaForMonster/entities/monster_preview.xml",x,y)
    print("load a "..monster_data.name.." at: x "..tostring(x)..", y "..tostring(y))
    local sprite_comp = EntityGetFirstComponentIncludingDisabled(preview_enity,"SpriteComponent","character")
    ComponentSetValue2(sprite_comp,"image_file",sprite)
    ComponentSetValue2(sprite_comp,"offset_x",offset_x)
    ComponentSetValue2(sprite_comp,"offset_y",offset_y)
    ComponentSetValue2(sprite_comp,"alpha",1)


    local var_comp = EntityGetFirstComponentIncludingDisabled(preview_enity,"VariableStorageComponent")
    ComponentSetValue2(var_comp,"value_string",monster_data.filepath)
    ComponentSetValue2(var_comp,"value_int",tribes)
    ComponentSetValue2(var_comp,"value_float",monster_data.value/10)

    local hp_bar_comp = EntityGetFirstComponentIncludingDisabled(preview_enity,"SpriteComponent","hp_bar")
    local hp_bar_y = math.max(offset_y,10)/0.4 + 4
    ComponentSetValue2(hp_bar_comp,"offset_y",hp_bar_y)
    ComponentSetValue2(hp_bar_comp,"special_scale_x",math.max(offset_x,10)/3 )

    local hp_value_comp = EntityGetFirstComponentIncludingDisabled(preview_enity,"SpriteComponent","hp_value")
    local hp_value = tostring(math.floor(monster_data.value*2.5))
    local text_length = string.len(hp_value)
    ComponentSetValue2(hp_value_comp,"offset_y",hp_bar_y + 1)
    ComponentSetValue2(hp_value_comp,"offset_x",text_length * 2)
    --ComponentSetValue2(hp_value_comp,"alpha",1)
    --ComponentSetValue2(hp_value_comp,"text",hp_value)

    if tribes == TRIBES.hiis then
        EntitySetTransform(preview_enity,x,y,0,-1)
        ComponentSetValue2(hp_bar_comp,"image_file","mods/ArenaForMonster/gfx/hp_bar_blue.png")
    else
        ComponentSetValue2(hp_bar_comp,"image_file","mods/ArenaForMonster/gfx/hp_bar_red.png")
    end
end

function number_table_to_string(list)
    local final_text = ""
    for i,number in pairs(list) do
        final_text = final_text .. tostring(number)
        if i~= #list then
            final_text = final_text .. ","
        end
    end
    return final_text
end

function number_string_to_table(text)
    if text == "" then
        return {}
    end
    if string.sub(text,1,1) == "," then
        return {}
    end
    local text_number = tonumber(text)
    if text_number ~= nil then
        return {text_number}
    end

    local final_table ={}
    --local current_index = 1
    local last_index = 1
    for i = 1,#text do
        local number_text = nil 

        if  i > last_index or i == #text then
            --print("character at i is:"..string.sub(text,i,i))
            if string.sub(text,i,i) == "," then
                --print("last idex:"..tostring(last_index))
                --print("current idex:"..tostring(i))
                number_text = string.sub(text,last_index,i-1)
                last_index = i + 1
            elseif i == #text then
                number_text = string.sub(text,last_index,i) 
            end
            --print(number_text)
            number_text = tonumber(number_text)
            if number_text ~= nil then
                table.insert(final_table,number_text)
            else
                --print("There is a no number string in:"..text..", at "..tostring(i))
            end

        end
    end
    return final_table
end

function draw_select_rectangle(gui,id_start,x1,y1,x2,y2)
    local x = math.min(x1,x2)
    local y = math.min(y1,y2)
    local height = math.max(math.abs( y1-y2),1) 
    local width = math.max(math.abs(x1-x2),1)
    --GuiText(gui,x,y-10,tostring(x)..","..tostring(y))
    --GuiText(gui,x+width,y + height,tostring(x+width)..","..tostring(y + height))
    GuiZSet( gui, 0.22 )
    if id_start == nil then id_start = 374862 end
    GuiOptionsAdd( gui, GUI_OPTION.NonInteractive) 
    GuiImage( gui, id_start, x,y, "mods/ArenaForMonster/gfx/select_rectangle/background.png", 1,width/20, height/20)
    GuiZSet( gui, 0.2 )
    GuiImage( gui, id_start+1, x,y, "mods/ArenaForMonster/gfx/select_rectangle/board.png", 1,width+1,1)
    GuiImage( gui, id_start+3, x,y, "mods/ArenaForMonster/gfx/select_rectangle/board.png", 1,1,height+1)
    GuiImage( gui, id_start+2, x+1,y+height, "mods/ArenaForMonster/gfx/select_rectangle/board.png", 1,width,1)
    GuiImage( gui, id_start+4, x+width,y+1, "mods/ArenaForMonster/gfx/select_rectangle/board.png", 1,1,height)

    GuiZSet( gui, 0 )
    GuiOptionsClear( gui) 
    return id_start + 5
end
function get_entity_in_rec_with_tag(x1,y1,x2,y2,tag)
    local radius = math.sqrt((x1 -x2)^2 + (y1-y2)^2)/2
    local result ={}
    local entities  = EntityGetInRadiusWithTag( (x1+x2)/2, (y1+y2)/2, radius, tag )
    for _,entity in pairs(entities) do
        local x,y = EntityGetTransform(entity)
        local x_in = false
        local y_in = false
        if x> math.min(x1,x2) and x < math.max(x1,x2) and y>math.min(y1,y2) and y < math.max(y1,y2) then
            table.insert(result,entity)
        end
    end
    return result
end

function raw_pos_to_world(x,y)
    local xc,yc = GameGetCameraPos()
    local xw =x/3 + xc - 1280/6
    local yw =y/3 + yc - 720/6
    return xw,yw
end

function get_spawn_info(preview_id)
    local monster_info = {
        filepath = nil,
        tribes = nil,
        hp = nil,
        hp_is_modified = false,
        modified_hp = nil,
    }
    local modifier_list = {}
    local var_comps = EntityGetComponentIncludingDisabled(preview_id,"VariableStorageComponent")

    if var_comps == nil then
        return nil
    end
    local hp_is_modified = false
    for _, var_comp in pairs(var_comps) do
        local name = ComponentGetValue2(var_comp,"name")
        if name == "monster_info" then
            monster_info.filepath = ComponentGetValue2(var_comp,"value_string")
            monster_info.tribes = ComponentGetValue2(var_comp,"value_int")
            monster_info.hp = ComponentGetValue2(var_comp,"value_float")
        elseif name == "creature_modifier" then
            --print("string get in get_spawn_info:"..ComponentGetValue2(var_comp,"value_string"))
            modifier_list = number_string_to_table(ComponentGetValue2(var_comp,"value_string"))
            --print("table lenth:"..tostring(#modifier_list))
        elseif name == "hp_modify" then
            monster_info.modified_hp = ComponentGetValue2(var_comp,"value_float")
            monster_info.hp_is_modified = ComponentGetValue2(var_comp,"value_bool")
        end
    end
    return monster_info,modifier_list
end

