function change_shot_entity(entity_id,shot_file)
    local ai_comps = EntityGetComponentIncludingDisabled(entity_id,"AnimalAIComponent")
    if ai_comps == nil then
        print("no animal ai comp?")
        return
    end
    for _,comp in pairs(ai_comps) do
        ComponentSetValue2(comp,"attack_ranged_entity_file",shot_file)
    end
    --[[
    local ai_comps = EntityGetComponentIncludingDisabled(entity_id,"AIAttackComponent")
    if ai_comps == nil then
        print("no ai attck comp?")
        return
    end
    for _,comp in pairs(ai_comps) do
        ComponentSetValue2(comp,"attack_ranged_entity_file",shot_file)
    end

    ]]--

end
function change_blood_material(entity_id,material_name)
    local damage_comp = EntityGetFirstComponentIncludingDisabled(entity_id,"DamageModelComponent")
    if damage_comp == nil then
        print("no damage comp?")
        return
    end
    ComponentSetValue2(damage_comp,"blood_material",material_name)
    ComponentSetValue2(damage_comp,"blood_spray_material",material_name)
end

monster_modifier_list = {
    ------------------add lua comp
    --shot effect
    {
        name = "no friendly fire",
        func = function(entity_id)
            EntityAddComponent2(entity_id,"LuaComponent",{
                script_shot="mods/ArenaForMonster/scripts/effect_scripts/disable_friend_damage.lua",
		        execute_every_n_frame=-1,
            })
        end
    },
    {
        name = "pingpong track",
        func = function(entity_id)
            EntityAddComponent2(entity_id,"LuaComponent",{
                script_shot="mods/ArenaForMonster/scripts/effect_scripts/add_pingpong_path.lua",
		        execute_every_n_frame=-1,
            })
        end
    },
    {
        name = "boomerang track",
        func = function(entity_id)
            EntityAddComponent2(entity_id,"LuaComponent",{
                script_shot="mods/ArenaForMonster/scripts/effect_scripts/boomerang.lua",
		        execute_every_n_frame=-1,
            })
        end
    },
    {
        name = "high gravity track",
        func = function(entity_id)
            EntityAddComponent2(entity_id,"LuaComponent",{
                script_shot="mods/ArenaForMonster/scripts/effect_scripts/add_high_gravity.lua",
		        execute_every_n_frame=-1,
            })
        end
    },
    {
        name = "anti-gravity track",
        func = function(entity_id)
            EntityAddComponent2(entity_id,"LuaComponent",{
                script_shot="mods/ArenaForMonster/scripts/effect_scripts/add_anti-gravity.lua",
		        execute_every_n_frame=-1,
            })
        end
    },

    --[[

    {
        name = "bullet counteract",
        func = function(entity_id)
            EntityAddComponent2(entity_id,"LuaComponent",{
                script_shot="mods/ArenaForMonster/scripts/effect_scripts/add_counteract.lua",
		        execute_every_n_frame=-1,
            })
        end
    },

    ]]--

    ------------------child eneity
    --[[
    {
        name = "tiny ghost",
        func = function(entity_id)
            local effect_id = EntityLoad("")
            EntityAddChild(entity_id,effect_id)
        end
    },
    ]]
    ------------------damage model modify
    {
        name = "blood material: acid",
        func = function(entity_id)
            change_blood_material(entity_id,"acid")
        end
    },
    {
        name = "blood material: Gas",
        func = function(entity_id)
            change_blood_material(entity_id,"acid_gas")
        end
    },
    {
        name = "blood material: lava",
        func = function(entity_id)
            change_blood_material(entity_id,"lava")
        end
    },
    {
        name = "blood material: radioactive",
        func = function(entity_id)
            change_blood_material(entity_id,"radioactive_liquid")
        end
    },
    {
        name = "blood material: cold",
        func = function(entity_id)
            change_blood_material(entity_id,"blood_cold_vapour")
        end
    },
    {
        name = "blood squirt on hit",
        func = function(entity_id)
            EntityLoadToEntity("mods/ArenaForMonster/entities/effect_entity/material_tank.xml",entity_id)
            local damage_comp = EntityGetFirstComponentIncludingDisabled(entity_id,"DamageModelComponent")
            if damage_comp ~= nil then
                local blood_material = ComponentGetValue2(damage_comp,"blood_material")
                if blood_material ~= nil then
                    local comp = EntityGetFirstComponentIncludingDisabled(entity_id,"MaterialInventoryComponent")
                    if comp == nil then
                        print("what happen?")
                        return
                    end
                    AddMaterialInventoryMaterial(entity_id,blood_material,800)
                end
            end
        end
    },

    ------------------AI modify
    --misc
    {
        name = "increse projectiles",
        func = function(entity_id)
            local ai_comps = EntityGetComponentIncludingDisabled(entity_id,"AnimalAIComponent")
            if ai_comps == nil then
                print("no ai comp?")
                return
            end
            for _,comp in pairs(ai_comps) do
                ComponentSetValue2(comp,"attack_ranged_entity_count_min ",5)
                ComponentSetValue2(comp,"attack_ranged_entity_count_max ",10)
            end
        end
    },
    {
        name = "increse knockback",
        func = function(entity_id)
            local ai_comps = EntityGetComponentIncludingDisabled(entity_id,"AnimalAIComponent")
            if ai_comps == nil then
                print("no ai comp?")
                return
            end
            for _,comp in pairs(ai_comps) do
                ComponentSetValue2(comp,"attack_knockback_multiplier",10)
            end
        end
    },
    {
        name = "aim ally(for healer)",
        func = function(entity_id)
            local ai_comps = EntityGetComponentIncludingDisabled(entity_id,"AnimalAIComponent")
            if ai_comps == nil then
                print("no ai comp?")
                return
            end
            for _,comp in pairs(ai_comps) do
                ComponentSetValue2(comp,"tries_to_ranged_attack_friends",true)
            end
        end
    },
    {
        name = "no counterattack",
        func = function(entity_id)
            local ai_comps = EntityGetComponentIncludingDisabled(entity_id,"AnimalAIComponent")
            if ai_comps == nil then
                print("no ai comp?")
                return
            end
            for _,comp in pairs(ai_comps) do
                ComponentSetValue2(comp,"dont_counter_attack_own_herd",true)
            end
        end
    },
    --shot change
    {
        name = "bullet change: firework",
        func = function(entity_id)
            SetRandomSeed( GameGetFrameNum(), entity_id )
			local types = {"pink","green","blue","orange"}
			local rnd = Random(1, #types)
			local firework_name = "firework_" .. tostring(types[rnd]) .. ".xml"
            change_shot_entity(entity_id,"data/entities/projectiles/deck/fireworks/" .. firework_name)
        end
    },
    {
        name = "bullet change: sawblade",
        func = function(entity_id)
            change_shot_entity(entity_id,"data/entities/projectiles/deck/disc_bullet.xml")
        end
    },
    {
        name = "bullet change: concentrated light",
        func = function(entity_id)
            change_shot_entity(entity_id,"data/entities/projectiles/deck/laser.xml")
        end
    },
    {
        name = "bullet change: tentacle",
        func = function(entity_id)
            change_shot_entity(entity_id,"data/entities/projectiles/deck/tentacle.xml")
        end
    },
    {
        name = "bullet change: healing bolt",
        func = function(entity_id)
            change_shot_entity(entity_id,"data/entities/projectiles/deck/heal_bullet.xml")
        end
    },
    {
        name = "bullet change: heal beam",
        func = function(entity_id)
            change_shot_entity(entity_id,"mods/ArenaForMonster/entities/projectile/heal_beam.xml")
        end
    },
    --[[
    {
        name = "bullet change: mega heal beam",
        func = function(entity_id)
            change_shot_entity(entity_id,"data/entities/projectiles/deck/heal_bullet.xml")
        end
    },
]]--

}