dofile( "data/scripts/lib/utilities.lua" )
dofile("mods/ArenaForMonster/scripts/arena_utili.lua")
dofile("mods/ArenaForMonster/scripts/list/creature_modifier_list.lua")
local created_gui = false
if not _monster_arena_gui then
    print("Creating arena GUI")
    _monster_arena_gui = GuiCreate()
    created_gui = true
else
    print("Reloading onto existing GUI")
end
local gui = _monster_arena_gui


--dofile("mods/ArenaForMonster/scripts/lib.lua")
--local overall_biome_data = dofile("mods/ArenaForMonster/scripts/load_monster_list.lua")
overall_biome_data = dofile("mods/ArenaForMonster/scripts/load_monster_list.lua")

local biome_menu_tab = {}
local modifier_sub_menu_info = {
    tab = {"modifier list"},
    selected_tab = 1,
    scroll_pos = 1,
}
local main_tab = {
    "monsters",
    "modify",
    "arena",
    "misc",
}
for i,biome_data in pairs(overall_biome_data) do
    print("Biome "..biome_data.name.." insert to menu.")
    table.insert(biome_menu_tab,biome_data.name)
    --[[
    for _,monster_data in pairs(biome_data.content) do 
        print("Monster name:"..monster_data.name)
        print("monster path:"..monster_data.filepath)
    end
    ]]--
end

--screen width = 640
local first_line_indent = 20;
local line_space = 20
local main_menu_width = 220
local main_menu_x_start = 640 - main_menu_width - first_line_indent
local main_menu_y_start = line_space*3
menu_id_start = 9784
button_id_start = 45972
modify_menu_id_start = 387941
monster_num_one_page = 6
selected_main_tab_index = 1
selected_biome = 0
selected_monster = 0
monster_scroll_pos = 1

selected_preview_in_world = {}
selected_tribes = TRIBES.rat
fire_enable = false

click_info = {
    first_click = nil,
}

arena_list = {
    ["Forest"] = {
        x = -17000,
        y = -100,
        file = "mods/ArenaForMonster/arena_scene/arena_forest.xml",
        pixel_scene="mods/ArenaForMonster/arena_scene/arena_forest.png"
    },
    ["Lava"] = {
        x = -17000,
        y = 3100,
        file = "mods/ArenaForMonster/arena_scene/arena_lava.xml",
        pixel_scene="mods/ArenaForMonster/arena_scene/arena_lava.png"
    },
    ["Radioactive"] = {
        x = -17000,
        y = 2100,
        file = "mods/ArenaForMonster/arena_scene/arena_radioactive.xml",
        pixel_scene="mods/ArenaForMonster/arena_scene/arena_radioactive.png"
    },
    ["Factory"] = {
        x = -17000,
        y = 1100,
        file = "mods/ArenaForMonster/arena_scene/arena_steel.xml",
        pixel_scene="mods/ArenaForMonster/arena_scene/arena_steel.png"
    },
    ["The work"] = {
        x = -17000,
        y = 4100,
        file = "mods/ArenaForMonster/arena_scene/arena_the_work.xml",
        pixel_scene="mods/ArenaForMonster/arena_scene/arena_the_work.png",
		pixel_scene_visual="mods/ArenaForMonster/arena_scene/arena_the_work_visual.png"
    },
}

misc_tools = {
    "eraser"
}
selected_misc_tools = ""

------------basic function
function mouse_is_hover_menu(mouse_x,mouse_y,menu_height)
    local x_diff = mouse_x - main_menu_x_start*2
    local y_diff = mouse_y - (main_menu_y_start + line_space/2)*2
    menu_height = menu_height-line_space
    if x_diff >0 and y_diff >0 then
        if x_diff < main_menu_width*2 and y_diff < menu_height*2 then
            return true
        end
    end
    return false
end
function block_fire(x,y)
    GuiZSet( gui, 0.1 )
    --TODO:use a bigger mask
    local clicked,right_clicked = GuiImageButton(  gui,2684236, x/2-16,y/2-16, "", "mods/ArenaForMonster/gfx/clicker_mask.png" )
    if clicked then
        print("click blocker is pressed!")
    end
    GuiZSet( gui, 0 )
    return clicked,right_clicked
    --GuiImage( gui,2684236, x,y, "mods/ArenaForMonster/gfx/mask_flat.png", 1)
end
function change_tribes()
    if selected_tribes == TRIBES.rat then
        selected_tribes = TRIBES.hiis
    else
        selected_tribes = TRIBES.rat
    end
    for _,preview_id in pairs(selected_preview_in_world) do
        local var_comp --TODO:
    end
end
function change_combat_state()
    if  GlobalsGetValue( "MONSTER_ARENA_STATE", "preview" ) == "preview" then
        GlobalsSetValue( "MONSTER_ARENA_STATE",  "combat" ) 
    else
        GlobalsSetValue( "MONSTER_ARENA_STATE",  "preview" ) 
        local player_id = EntityGetWithTag("player_unit")[1]
        if player_id ~= nil then --TODO: add a pause effect. even I dont think its could be realized
            local x,y = EntityGetTransform(player_id)
            local previews = EntityGetInRadiusWithTag( x,y,200, "mod_monster_preview" )
            if previews ~= nil then
                for _,id in pairs(previews) do
                    --EntityKill(id) 
                end
            end 
            local enemies = EntityGetInRadiusWithTag( x,y,200, "enemy" )
            if enemies ~= nil then
                for _,id in pairs(enemies) do
                    if id ~= player_id then
                        --EntityKill(id)
                    end
                end
            end 
        end
    end
end
function change_fire_enable()
    fire_enable = not fire_enable
    GlobalsSetValue("FIRE_ENABLE",tostring(fire_enable))
    if fire_enable then
        local inventory = EntityGetWithName("inventory_quick")
        local items = EntityGetAllChildren(inventory)
        for _,item in pairs(items) do
            --disable mana
            local ability_comp = EntityGetFirstComponentIncludingDisabled(item ,"AbilityComponent")
            if ability_comp ~= nil then
                local max_mana = ComponentGetValue2(ability_comp,"mana_max")
                if max_mana ~= nil then
                    ComponentSetValue2(ability_comp,"mana",max_mana)
                end
            end
        end
        local player_id = EntityGetWithTag("player_unit")[1]
        if player_id ~= nil then
            local damage_comp = EntityGetFirstComponentIncludingDisabled(player_id,"DamageModelComponent")
            if damage_comp ~= nil then
                EntitySetComponentIsEnabled(player_id,damage_comp,true)
            end
        end
    else
        local player_id = EntityGetWithTag("player_unit")[1]
        if player_id ~= nil then
            local damage_comp = EntityGetFirstComponentIncludingDisabled(player_id,"DamageModelComponent")
            if damage_comp ~= nil then
                EntitySetComponentIsEnabled(player_id,damage_comp,false)
            end
        end
    end
end
------------select menu
function click_blocking_mask(gui,x,y,width,height,id_start)
    y = y + line_space/2
    height = height - line_space
    --height = height - line_space
    local current_id = id_start
    local scale = width/20
    local single_mask_height = 10 * scale 
    if single_mask_height > height then
        print("can't create a so flat blocker,width:"..to_string(width)..",height:"..tostring(height))
        return current_id
    end
    GuiZSet( gui, 0.25 )

    --print("width:"..tostring(width))
    --print("height:"..tostring(height))
    local mask_num = math.floor(height / single_mask_height) +1
    --print("")
    for i=1,mask_num do
        local mask_y = y + height - i*single_mask_height
        if i == mask_num then
            mask_y = y
        end
        GuiImage( gui,current_id, x,mask_y, "mods/ArenaForMonster/gfx/mask_flat.png", 0,scale)
        --GuiText(gui,x,mask_y,"mask pos of number "..tostring(i))
        current_id = current_id +1
    end
    GuiZSet( gui, 0 )
    return current_id
end
function draw_text_box_tab(gui,x, y, width, height, id_start,down_board)
    y = y - line_space/2
    GuiZSet( gui, 0.22 )
    if width ==0 or height == 0 then return end
    if id_start == nil then id_start = 37894 end
    GuiOptionsAdd( gui, GUI_OPTION.NonInteractive) 
    GuiImage( gui, id_start, x,y, "mods/ArenaForMonster/gfx/text_background.png", 1,width/20, height/20)
    GuiZSet( gui, 0.2 )
    GuiImage( gui, id_start+1, x,y, "mods/ArenaForMonster/gfx/text_board.png", 1,width,1)
    GuiImage( gui, id_start+3, x,y, "mods/ArenaForMonster/gfx/text_board.png", 1,1,height)
    if down_board == false then
        GuiImage( gui, id_start+2, x+1,y+height, "mods/ArenaForMonster/gfx/text_board.png", 1,width,1)
    end
    GuiImage( gui, id_start+4, x+width,y+1, "mods/ArenaForMonster/gfx/text_board.png", 1,1,height)
    GuiImage( gui, id_start+5, x,y+height, "mods/ArenaForMonster/gfx/text_corner.png", 1,1)
    GuiImage( gui, id_start+6, x+width,y, "mods/ArenaForMonster/gfx/text_corner.png", 1,1)
    GuiZSet( gui, 0 )
    GuiOptionsClear( gui) 
    return id_start+7
end
function update_tab_button_by_table(x, y,width, id_start,tab,current_selected_index)
    --print("update tab!")

    if current_selected_index == nil then
        print("selected_index is nil!")
        current_selected_index = 0
    end
    local clicked_index = nil
    local current_id = id_start + 1

    local max_button_per_row = math.floor(width/50)
    --print("max button in a row:"..tostring(max_button_per_row))
    local rows = math.floor(#tab/max_button_per_row) 
    if rows * max_button_per_row - #tab < -0.001 then
        rows = rows +1
    end
    --print("rows:"..tostring(rows))
    for row = 1,rows do
        local buttons_this_row = math.min(#tab-(row-1)*max_button_per_row,max_button_per_row)
        if buttons_this_row == 0 then
            rows = rows -1
            break
        end
        local button_width = width/buttons_this_row
        local current_x = x 
        for i=1, buttons_this_row do 
            local index_in_tab = (row-1)*max_button_per_row + i
            local selected = false
            if index_in_tab == current_selected_index then
                selected = true
            end
            local current_y = y + line_space * (rows - row+1)
            local text_y = y - line_space/4 + line_space * (rows - row+1)

            current_id = draw_text_box_tab(gui,current_x,current_y,button_width,line_space,current_id,selected)
    
            local button_text  = tab[index_in_tab]
            button_text = GameTextGetTranslatedOrNot("$menu_tab_"..button_text)
            if selected then
                button_text = ">"..button_text.."<"
            end
            --GuiOptionsAdd(gui, GUI_OPTION.Align_HorizontalCenter )
            --GuiText( _monster_arena_gui,current_x,y-line_space/2, tab_name)

            if GuiButton(gui, current_id, current_x + 5, text_y, button_text) then
                print("tab of index "..tostring(index_in_tab).." pressed!")
                clicked_index = index_in_tab
            end
            --GuiOptionsRemove(gui, GUI_OPTION.Align_HorizontalCenter )
     
            current_x = current_x + button_width
            current_id = current_id + 1
        end

    end
    return current_id, clicked_index,rows
end
function draw_text_box_no_up_board(gui,x, y, width, height, id_start)
    y = y + line_space/2
    height = height - line_space
    GuiZSet( gui, 0.22 )
    if width ==0 or height == 0 then return end
    if id_start == nil then id_start = 37894 end
    GuiOptionsAdd( gui, GUI_OPTION.NonInteractive) 
    --GuiImage( gui:obj, id:int, x:number, y:number, sprite_filename:string, alpha:number = 1, scale:number = 1, scale_y:number = 0, rotation:number = 0, rect_animation_playback_type:int = GUI_RECT_ANIMATION_PLAYBACK.PlayToEndAndHide, rect_animation_name:string = "" )
    GuiImage( gui, id_start, x,y, "mods/ArenaForMonster/gfx/text_background.png", 1,width/20, height/20)

    --GuiImage( gui, id_start, x,y, "mods/ArenaForMonster/gfx/text_background.png", 1,1, 5)
    GuiZSet( gui, 0.2 )
    --GuiImage( gui, id_start+1, x,y, "mods/ArenaForMonster/gfx/text_board.png", 1,width,1)
    GuiImage( gui, id_start+3, x,y, "mods/ArenaForMonster/gfx/text_board.png", 1,1,height)
    GuiImage( gui, id_start+2, x+1,y+height, "mods/ArenaForMonster/gfx/text_board.png", 1,width,1)
    GuiImage( gui, id_start+4, x+width,y+1, "mods/ArenaForMonster/gfx/text_board.png", 1,1,height)
    GuiImage( gui, id_start+5, x,y+height, "mods/ArenaForMonster/gfx/text_corner.png", 1,1)
    GuiImage( gui, id_start+6, x+width,y, "mods/ArenaForMonster/gfx/text_corner.png", 1,1)
    GuiZSet( gui, 0 )
    GuiOptionsClear( gui) 
    return id_start+7
end
function reset_monster_scroll_pos()
    if selected_main_tab_index ~=1 then
        print("current menu is not biome menu")
        monster_scroll_pos = 1
        return
    end
    local biome = overall_biome_data[selected_biome]
    if biome == nil then
        print("biome data is nil or not chosen yet")
        monster_scroll_pos = 1
        return
    end

    if selected_monster < monster_scroll_pos + 2 then
        --index -1 or to 1
        print("index move up")
        monster_scroll_pos = math.max(1,monster_scroll_pos-1)
        return
    end

    local current_list_lenth = #(biome.content)

    if selected_monster > monster_scroll_pos + monster_num_one_page - 2 then
        --index +1 or max value
        print("index move down")
        monster_scroll_pos = math.min(monster_scroll_pos + 1,current_list_lenth-monster_num_one_page)
        return
    end


    --local index_start = math.max(1,selected_monster -math.floor(monster_num_one_page/2))
    
end
function update_biome_menu(x,y,id_start,width)
    --print("selected_main_tab_index at update_biome_menu start: "..tostring(selected_main_tab_index))
    local current_id,clicked_biome,tab_row = update_tab_button_by_table(x, y,width, id_start+1,biome_menu_tab,selected_biome)
    if clicked_biome ~= nil then
        selected_biome = clicked_biome
        selected_monster = 1
        reset_monster_scroll_pos()
    end
    local current_y = y + line_space * math.max(0.5,tab_row+0.5) 

    local clicked_monster_index = nil
    if selected_biome~= 0 then
        --print("selected_biome:"..tostring(selected_biome))
        local biome = overall_biome_data[selected_biome]
        if biome == nil then
            print("no biome of index:"..tostring(selected_biome))
        end
        local data = biome.content
        if data == nil then
            print("no monster data of index:"..tostring(selected_biome))
        end

        if selected_monster > #data then
            selected_monster = #data
        end

        for i = monster_scroll_pos, math.min(monster_scroll_pos+monster_num_one_page,#data)  do
            local monster_data =data[i]
            if monster_data == nil then
                print("scroll out of bound")
                print("scroll pos:"..tostring(monster_scroll_pos))
                print("data lenth:"..tostring(#data))
                break
            end
            local text = monster_data.name
            if type(text)~= "string" then
                print("can't get name")
                print("scroll pos:"..tostring(monster_scroll_pos))
                print("monster index:"..tostring(i))
                print("file path:"..monster_data.filepath)
                print("data lenth:"..tostring(#data))
                break
            end

            if i == selected_monster then
                text = "> "..GameTextGetTranslatedOrNot( text ) .." <"
            end
            current_y = current_y + line_space/2
            current_id = current_id+1
            if GuiButton( _monster_arena_gui, current_id, x + first_line_indent, current_y, text) then
                clicked_monster_index = i
            end

            local value = monster_data.value
            if value == nil then
                value = 10
            end
            GuiText(_monster_arena_gui,x + width - first_line_indent * 1.5,current_y," $"..tostring(value))
            current_id = current_id+1
        end
    end
    if clicked_monster_index ~= nil then
        selected_monster = clicked_monster_index
        reset_monster_scroll_pos()
    end
    --print("selected_main_tab_index at update_biome_menu end: "..tostring(selected_main_tab_index))
    local text_box_hight = current_y + line_space* 1.5 - y
    if (text_box_hight - line_space) < width/2 then
        text_box_hight = width/2 + line_space
    end
    current_id= draw_text_box_no_up_board(gui,x,y,width,text_box_hight,current_id)
    current_id = click_blocking_mask(gui,x,y,width,text_box_hight,current_id)
    return current_id,current_y+line_space
end

------------------modify menu
function set_hp_is_modified(is_modified)
    for _,preview_id in pairs(selected_preview_in_world) do
        if is_modified then
            local var_comps = EntityGetComponentIncludingDisabled(preview_id,"VariableStorageComponent")
            local has_hp_var_comp = false
            for _, var_comp in pairs(var_comps) do
                local name = ComponentGetValue2(var_comp,"name")
                if name == "hp_modify" then
                    has_hp_var_comp = true
                    ComponentSetValue2(var_comp,"value_bool",true)
                end
            end
            if has_hp_var_comp == false then
                EntityAddComponent2(preview_id,"VariableStorageComponent",{
                    name =  "hp_modify",
                    value_bool = true,
                    value_float = 1.0,
                })
            end
        else
            local var_comps = EntityGetComponentIncludingDisabled(preview_id,"VariableStorageComponent")
            for _, var_comp in pairs(var_comps) do
                local name = ComponentGetValue2(var_comp,"name")
                if name == "hp_modify" then
                    ComponentSetValue2(var_comp,"value_bool",false)
                end
            end
        end
    end
end
function set_preview_hp(hp)
    local hp =math.min(360,math.max(0.04,hp)) 
    for _,preview_id in pairs(selected_preview_in_world) do
        local var_comps = EntityGetComponentIncludingDisabled(preview_id,"VariableStorageComponent")
        local has_hp_var_comp = false
        for _, var_comp in pairs(var_comps) do
            local name = ComponentGetValue2(var_comp,"name")
            if name == "hp_modify" then
                ComponentSetValue2(var_comp,"value_float",hp)
                has_hp_var_comp = true
            end
        end
        if has_hp_var_comp == false then
            EntityAddComponent2(preview_id,"VariableStorageComponent",{
                name =  "hp_modify",
                value_float = hp,
            })
        end
    end
end
function set_modifier_enabled(modifier_index,enabled)
    print("set preview modifier")
    for _,preview_id in pairs(selected_preview_in_world) do
        local var_comps = EntityGetComponentIncludingDisabled(preview_id,"VariableStorageComponent")
        local modifier_comp
        local modifier_list = {}
        for _, var_comp in pairs(var_comps) do
            local name = ComponentGetValue2(var_comp,"name")
            if name == "creature_modifier" then
                modifier_comp = var_comp
                print("value string get from entity:"..ComponentGetValue2(var_comp,"value_string"))
                modifier_list = number_string_to_table(ComponentGetValue2(var_comp,"value_string"))
            end
        end
        if modifier_comp ~= nil then
            if enabled then
                print("add index of:"..tostring(modifier_index))
                local already_have = false
                for i = 1,#modifier_list do
                    if modifier_list[i] == modifier_index then
                        already_have = true
                    end
                end
                if already_have == false then
                    table.insert(modifier_list,modifier_index)
                end
            else
                print("remove index of:"..tostring(modifier_index))
                for i = 1,#modifier_list do
                    if modifier_list[i] == modifier_index then
                        table.remove(modifier_list,i)
                    end
                end
            end

            local modifier_srting = number_table_to_string(modifier_list)
            print("value string going to set:"..modifier_srting)
            ComponentSetValue2(modifier_comp,"value_string",modifier_srting )
        else
            print("No modifier comp!")
        end
    end
end
function get_selected_monster_display_info()
    local monster_info_display = {
        --tribes = nil,
        hp = nil,
        hp_is_modified = nil,
        modified_hp = nil,
    }
    local has_modifier = {}

    if selected_main_tab_index == 2 and #selected_preview_in_world ~= 0 then
        local hp_modified_inconsistent = false
        for _,preview_entity in pairs(selected_preview_in_world) do
            local monster_info = {
                filepath = nil,
                tribes = nil,
                hp = nil,
                hp_is_modified = nil,
                modified_hp = nil,
            }
            local modifier_list ={}
            monster_info,modifier_list = get_spawn_info(preview_entity)

            if monster_info == nil then
                return
            end

            if monster_info_display.hp == nil then
                monster_info_display.hp = monster_info.hp
            elseif monster_info_display.hp ~= monster_info.hp then
                --negtive hp means has a inconsistent hp
                monster_info_display.hp = -monster_info.hp
            end

            if monster_info_display.modified_hp == nil then
                monster_info_display.modified_hp = monster_info.modified_hp
            elseif monster_info_display.modified_hp ~= monster_info.modified_hp then
                --negtive hp means has a inconsistent hp
                monster_info_display.modified_hp = -monster_info.modified_hp
            end

            if monster_info_display.hp_is_modified == nil then
                monster_info_display.hp_is_modified = monster_info.hp_is_modified
            elseif monster_info_display.hp_is_modified ~= monster_info.hp_is_modified then
                hp_modified_inconsistent = true
            end



            for _,modifier_index in pairs(modifier_list) do
                if has_modifier[modifier_index] == nil then
                    has_modifier[modifier_index] = 1
                else
                    has_modifier[modifier_index] = has_modifier[modifier_index] +1
                end
            end
        end
        if hp_modified_inconsistent then
            monster_info_display.hp_is_modified = nil
        end
    end
    return monster_info_display,has_modifier
end
function update_modifier_list(x,y,id_start,width,modifier_list_state)

    --print("selected_main_tab_index at update_biome_menu start: "..tostring(selected_main_tab_index))
    local current_id,clicked_tab,tab_row = update_tab_button_by_table(x, y,width, id_start+1,modifier_sub_menu_info.tab,modifier_sub_menu_info.selected_tab)
    if clicked_tab ~= nil then
        modifier_sub_menu_info.selected_tab = clicked_tab
        modifier_sub_menu_info.scroll_pos = 1
    end
    GuiOptionsAdd( gui,GUI_OPTION.NoPositionTween )
    local current_y = y + line_space * math.max(0.5,tab_row+0.5)
    local clicked_modifier_index = nil
    if modifier_sub_menu_info.selected_tab~= 0 then
        for i = modifier_sub_menu_info.scroll_pos, math.min(modifier_sub_menu_info.scroll_pos+monster_num_one_page,#modifier_list_state) do
            local check_box_texture
            if modifier_list_state[i] == 0 then
                check_box_texture = "mods/ArenaForMonster/gfx/ui_check/unpick.png"
            elseif modifier_list_state[i] == -1 then
                check_box_texture = "mods/ArenaForMonster/gfx/ui_check/halfpick.png"
            else
                check_box_texture = "mods/ArenaForMonster/gfx/ui_check/pick.png"
            end
            if GuiImageButton(gui,current_id,x + first_line_indent,current_y,"",check_box_texture) then
                --get clicked modifier index
                clicked_modifier_index = i
            end

            local modifier_text= GameTextGetTranslatedOrNot("$creature_modifier_"..monster_modifier_list[i].name)

            GuiText(gui,x +first_line_indent + 12,current_y,modifier_text)
            current_id = current_id+1
            current_y = current_y + line_space * 2 /3
        end
    end
    GuiOptionsClear( gui)
    if clicked_modifier_index ~= nil then
        --switch modifer selected
        if modifier_list_state[clicked_modifier_index] >0 then
            set_modifier_enabled(clicked_modifier_index,false)
        else
            set_modifier_enabled(clicked_modifier_index,true)
        end
    end
    --print("selected_main_tab_index at update_biome_menu end: "..tostring(selected_main_tab_index))
    local text_box_hight = current_y + line_space - y
    if (text_box_hight - line_space) < width/2 then
        text_box_hight = width/2 + line_space
    end
    current_id= draw_text_box_no_up_board(gui,x,y,width,text_box_hight,current_id)
    --current_id = click_blocking_mask(gui,x,y,width,text_box_hight,current_id)

    return current_id,current_y
end
function update_monster_info_display_menu(gui,x,y,id_start,width,monster_info_display)
    local current_id = id_start + 1
    local current_y = y

    --update hp information
    local hp_check_box_icon
    if monster_info_display.hp_is_modified == false then
        hp_check_box_icon = "mods/ArenaForMonster/gfx/ui_check/unpick.png"
    elseif monster_info_display.hp_is_modified == true then
        hp_check_box_icon = "mods/ArenaForMonster/gfx/ui_check/pick.png"
    else
        hp_check_box_icon = "mods/ArenaForMonster/gfx/ui_check/halfpick.png"
    end

    GuiOptionsAdd( gui,GUI_OPTION.NoPositionTween )
    if GuiImageButton(gui,current_id,x,current_y,"",hp_check_box_icon) then
        --switch modifer of hp
        print("hp modified of modify menu clicked")
        if monster_info_display.hp_is_modified == true then
            set_hp_is_modified(false)
        else
            set_hp_is_modified(true)
        end
    end
    GuiText(gui,x + 12,current_y,GameTextGetTranslatedOrNot("$modifier_menu_text_modify_hp"))
    GuiOptionsClear(gui)
    current_id = current_id +1 
    current_y = current_y + line_space * 2 /3

    local hp_text = ""
    if monster_info_display.hp_is_modified == true then
        hp_text = tostring(math.abs(math.floor(monster_info_display.modified_hp *25 +0.5)))
        if monster_info_display.modified_hp <0 then
            hp_text = hp_text.."..."
        end
    elseif monster_info_display.hp ~= nil then
        hp_text = tostring(math.abs(math.floor(monster_info_display.hp *25 +0.5)))
        if monster_info_display.hp <0 then
            hp_text = hp_text.."..."
        end
    end


    GuiText(gui,x,current_y,"HP:")
    GuiText(gui,x+width/2,current_y,hp_text)
    local add_hp_clicked
    if monster_info_display.hp_is_modified == true then
        if GuiButton(gui,current_id,x+0.25*width,current_y,"<-25>") then
            add_hp_clicked = false
        end
        current_id = current_id +1
        if GuiButton(gui,current_id,x+0.75*width,current_y,"<+25>") then
            add_hp_clicked = true
        end
        current_id = current_id +1
    end
    if add_hp_clicked == true then
        set_preview_hp(math.abs(monster_info_display.modified_hp) + 1)
    elseif add_hp_clicked == false then
        set_preview_hp(math.abs(monster_info_display.modified_hp) - 1)
    end
    current_y = current_y + line_space/2
    

    return current_id,current_y
end
function update_modify_menu(x,y,id_start,width)
    local current_id = id_start +1
    local current_y = y + line_space/2

    if GlobalsGetValue( "MONSTER_ARENA_STATE", "preview" ) ~= "preview" then
        selected_preview_in_world = {}
    end
    local monster_info_display = {
        --tribes = nil,
        hp = nil,
        hp_is_modified = nil,
        modified_hp = nil,
    }
    local monster_modifiers = {}
    monster_info_display,monster_modifiers = get_selected_monster_display_info()
    if monster_info_display == nil then
        selected_preview_in_world = {}
        return current_id,current_y+line_space
    end

    --update info menu
    current_id,current_y = update_monster_info_display_menu(gui,x,current_y,current_id,width ,monster_info_display)
    --get modifier state
    local modifier_list_state = {}
    for i=1,#monster_modifier_list do
        if monster_modifiers[i] == nil then
            modifier_list_state[i] = 0
        elseif monster_modifiers[i] == #selected_preview_in_world then
            modifier_list_state[i] = 1
        else
            modifier_list_state[i] = -1
        end
    end
    --update modifier sub menu
    current_id,current_y =  update_modifier_list(x,current_y,current_id + 1,width,modifier_list_state)

    return current_id,current_y+line_space 
end

------------------arena menu
function update_arena_menu(x,y,id_start,width)
    local current_id = id_start +1
    local current_y = y + line_space/2
    
    GuiText(gui,x,current_y,GameTextGetTranslatedOrNot("$arena_name_Overworld"))
    if GuiButton(gui,current_id,x+ width/4 + 20,current_y,GameTextGetTranslatedOrNot("$arena_button_teleport")) then
        local player_id = EntityGetWithTag("player_unit")[1]
        if player_id ~= nil then
            EntitySetTransform(player_id,0,-150)
        end
    end
    current_id = current_id + 1
    current_y = current_y + line_space

    for arena_name,info in pairs(arena_list) do
        local name_text = GameTextGetTranslatedOrNot("$arena_name_"..arena_name)
        GuiText(gui,x,current_y,name_text)
        if GuiButton(gui,current_id,x+ width/4 + 20,current_y,GameTextGetTranslatedOrNot("$arena_button_teleport")) then
            local player_id = EntityGetWithTag("player_unit")[1]
            if player_id ~= nil then
                EntitySetTransform(player_id,info.x,info.y)
            end
        end
        current_id = current_id +1

        --[[

        if GuiButton(gui,current_id,x + width/2,current_y,"reload") then
            local player_id = EntityGetWithTag("player_unit")[1]
            if player_id ~= nil then
                local color_file = ""
                if info.pixel_scene_visual ~= nil then
                    color_file = info.pixel_scene_visual
                end
                LoadPixelScene(info.pixel_scene, color_file,info.x - 256, info.y -192,"", true)
                EntityLoad(info.file,info.x,info.y)
            end
        end
        current_id = current_id +1
        ]]


        --spawn trees
        if arena_name == "Forest" then
            if GuiButton(gui,current_id,x + width*0.75 - 6,current_y,GameTextGetTranslatedOrNot("$arena_button_spawn trees")) then
                SetRandomSeed(GameGetFrameNum(),GameGetFrameNum())
                local spread_width = 480
                local x_start = info.x -spread_width/2
                for i = 1,16 do
                    load_random_tree(x_start,info.y)
                    x_start = x_start + spread_width/16
                end
            end
        end
        current_id = current_id +1
        --spawn trap
        if arena_name == "Factory" then
            if GuiButton(gui,current_id,x + width*0.75 - 6,current_y,GameTextGetTranslatedOrNot("$arena_button_spawn traps")) then
                EntityLoad("data/entities/_debug/physics2_trap_electricity_enabled.xml",info.x,info.y + 157)
                EntityLoad("data/entities/_debug/physics2_trap_electricity_enabled.xml",info.x-129,info.y + 157)
                EntityLoad("data/entities/_debug/physics2_trap_electricity_enabled.xml",info.x+129,info.y + 157)
            end
        end
        current_id = current_id +1
        --spawn bridge
        if arena_name == "Lava" then
            if GuiButton(gui,current_id,x + width*0.75 - 6,current_y,GameTextGetTranslatedOrNot("$arena_button_spawn bridge")) then
                EntityLoad("mods/ArenaForMonster/arena_scene/bridge_spawner.xml",info.x-190,info.y+75)
                EntityLoad("mods/ArenaForMonster/arena_scene/bridge_spawner.xml",info.x + 40,info.y+ 45)

                EntityLoad("mods/ArenaForMonster/arena_scene/bridge_spawner_mirror.xml",info.x + 190,info.y+ 70)
                EntityLoad("mods/ArenaForMonster/arena_scene/bridge_spawner_mirror.xml",info.x - 40,info.y+ 40)
            end
        end
        current_id = current_id +1
        current_y = current_y + line_space
    end
    return current_id,current_y
end
------------------misc menu
function update_misc_menu(x,y,id_start,width)
    local current_id = id_start +1
    local current_y = y + line_space/2

    GuiText(gui,x,current_y,GameTextGetTranslatedOrNot("$misc_menu_text_misc_tools"))
    current_y = current_y +  line_space/2
    
    for _,button in pairs(misc_tools) do
        local button_text = GameTextGetTranslatedOrNot("$main_button_Eraser")
        if selected_misc_tools == button then
            button_text = ">"..button_text.."<"
        end

        if GuiButton(gui,current_id,x+ width/4,current_y,button_text) then
            selected_misc_tools = button
        end
        current_id = current_id + 1
        current_y = current_y + line_space/2
    end

    current_y = current_y + line_space/2
    if GuiButton(gui,current_id,x,current_y,GameTextGetTranslatedOrNot("$misc_menu_button_kill_all")) then
        local player_id = EntityGetWithTag("player_unit")[1]
        if player_id ~= nil then
            local x,y = EntityGetTransform(player_id)
            local previews = EntityGetInRadiusWithTag( x,y,200, "mod_monster_preview" )
            if previews ~= nil then
                for _,id in pairs(previews) do
                    EntityKill(id)
                end
            end 
            local enemies = EntityGetInRadiusWithTag( x,y,200, "enemy" )
            if enemies ~= nil then
                for _,id in pairs(enemies) do
                    if id ~= player_id then
                        EntityKill(id)
                    end
                end
            end 
        end
   
    end
    current_id = current_id + 1
    current_y = current_y + line_space/2

    return current_id,current_y
end
------------------main menu
function update_main_menu(x,y,width,tab)
    local current_id = menu_id_start
    local tab_rows = 0
    local clicked_mian_tab_index = nil 
    --print("selected_main_tab_index at update_main_menu start: "..tostring(selected_main_tab_index))
    current_id,clicked_mian_tab_index,tab_rows = update_tab_button_by_table(x, y,width, menu_id_start+1,tab,selected_main_tab_index)


    if clicked_mian_tab_index ~= nil then
        selected_main_tab_index =  clicked_mian_tab_index
    end
    --print("selected_main_tab_index after update_tab_button_by_table: "..tostring(selected_main_tab_index))
    local current_y = y+line_space * (tab_rows)
    local current_id = current_id +1

    if selected_main_tab_index ~= 2 then
        --clean selected preivew
        if #selected_preview_in_world ~=0 then
            for _,previous_entity in pairs(selected_preview_in_world) do
                EntityRemoveTag(previous_entity,"mod_selected")
            end
            selected_preview_in_world = {}
        end
    end

    --update sub menu content
    if selected_main_tab_index == 1 then
        --update biome menu
        current_id,current_y = update_biome_menu(x+ first_line_indent,current_y+line_space,current_id,width-first_line_indent*2)
    elseif selected_main_tab_index == 2 then
        --modifier menu
        current_id,current_y = update_modify_menu(x+ first_line_indent,current_y+line_space,current_id,width-first_line_indent*2)
    elseif selected_main_tab_index == 3 then
        --arena teleport and reload menu
        current_id,current_y = update_arena_menu(x+ first_line_indent,current_y+line_space,current_id,width-first_line_indent*2)
    elseif selected_main_tab_index == 4 then
        --eraser menu?
        current_id,current_y = update_misc_menu(x+ first_line_indent,current_y+line_space,current_id,width-first_line_indent*2)
    end
    --print("selected_main_tab_index at update_main_menu end: "..tostring(selected_main_tab_index))
    --current_y = current_y + line_space
    local text_box_hight = current_y + line_space * 1.5 - y
    if (text_box_hight - line_space) < width/2 then
        text_box_hight = width/2 + line_space
    end
    current_id = draw_text_box_no_up_board(gui,x,y,width,text_box_hight,current_id)
    current_id = click_blocking_mask(gui,x,y,width,text_box_hight,current_id)
    current_id = current_id +1
    return current_id,text_box_hight
end
------------big button in screen central
function get_button_state()
    local main_button = {
        ["select"] = {
            icon = "mods/ArenaForMonster/gfx/select.png",
            text = "Select",
        },
        ["place"] = {
            icon = "mods/ArenaForMonster/gfx/place.png",
            text = "Place",
        },
        ["combat"] =  {
            icon = nil,
            text = "",
        },
        ["eraser"] = {
            icon = "mods/ArenaForMonster/gfx/eraser.png",
            text = "Eraser",
        },
        ["tribes"] ={
            icon = nil,
            text = "Factions",
        },
        ["fire_enable"] ={
            icon = nil,
            text = "",
        },
        
    }
    --set display information
    local combat_state = GlobalsGetValue( "MONSTER_ARENA_STATE", "preview" )
    if #selected_preview_in_world >0 then
        main_button["select"].icon = "mods/ArenaForMonster/gfx/move.png"
        main_button["select"].text= "Move"
    else
        main_button["select"].icon = "mods/ArenaForMonster/gfx/select.png"
        main_button["select"].text= "Select"   
    end
    if combat_state == "preview" then
        main_button["combat"].icon = "mods/ArenaForMonster/gfx/combat_start.png"
        main_button["combat"].text = "Preview"
    else
        main_button["combat"].icon = "mods/ArenaForMonster/gfx/combat_end.png"
        main_button["combat"].text = "Fight"
    end
    if selected_tribes == TRIBES.rat then
        main_button["tribes"].icon = "mods/ArenaForMonster/gfx/flag_red.png"
    else
        main_button["tribes"].icon = "mods/ArenaForMonster/gfx/flag_blue.png"
    end
    if fire_enable then
        main_button["fire_enable"].icon = "mods/ArenaForMonster/gfx/fire_enable.png"
        main_button["fire_enable"].text = "Join fight"
    else
        main_button["fire_enable"].icon = "mods/ArenaForMonster/gfx/fire_disable.png"
        main_button["fire_enable"].text = "Look on"
    end
    return main_button
end
function main_button_select_clicked()
    selected_main_tab_index = 2
    if #selected_preview_in_world ~=0 then
        for _,previous_entity in pairs(selected_preview_in_world) do
            EntityRemoveTag(previous_entity,"mod_selected")
        end
        selected_preview_in_world = {}
    end
end
function update_main_button()
    local button_distance = 64
    local current_id = button_id_start
    local y = 300
    --local x_central = 200
    --print("button update start")
    --GuiText(gui,x_central,y,"central")
   
    local main_button = get_button_state()
    local clicked_button = nil
    local x = 320- 64 *3
    for button_name,button_info in pairs(main_button) do
        if  GuiImageButton(gui,current_id,x + 16,y,"",button_info.icon) then
            clicked_button = button_name
        end
        local text = GameTextGetTranslatedOrNot("$main_button_"..button_info.text)
        GuiText(gui,x + 16,y+32,text)
        current_id = current_id +1
        x = x + 64
    end

    if clicked_button == "select" then
        main_button_select_clicked()
    elseif clicked_button == "tribes" then
        change_tribes()
    elseif clicked_button == "combat" then
        change_combat_state()
    elseif clicked_button == "eraser" then
        selected_main_tab_index = 4
        selected_misc_tools = "eraser"
    elseif clicked_button == "fire_enable" then
        change_fire_enable()
    elseif clicked_button =="place" then
        selected_main_tab_index = 1
    end

end
------------inputs(mainly keyboards), and mouse pos relating stuff
function update_player_input(id_start,menu_height)
    local current_id = id_start
    local player_id = EntityGetWithTag("player_unit")[1]
    local mouse_x,mouse_y,space,scroll_up,scroll_down,fire_down,mouse_x_world,mouse_y_world
    local clicked = false
    local right_clicked = false
    local interacted = false
    if player_id~= nil then
        edit_component2(player_id,"ControlsComponent",function (comp,vars)
            mouse_x_world,mouse_y_world = ComponentGetValue2( comp, "mMousePosition")
            mouse_x,mouse_y = ComponentGetValue2( comp, "mMousePositionRaw")
            fire_down= ComponentGetValue2( comp, "mButtonDownFire")
            if fire_down and ComponentGetValue2(comp,"mButtonFrameFire") ==GameGetFrameNum() then
                print("press frame:"..tostring(ComponentGetValue2(comp,"mButtonFrameFire").." current frame:"..tostring(GameGetFrameNum())))
                clicked = true
            end
            local right_click_down = ComponentGetValue2( comp, "mButtonDownRightClick")
            if right_click_down and  ComponentGetValue2(comp,"mButtonFrameRightClick") ==GameGetFrameNum() then
                right_clicked = true
            end

            space= ComponentGetValue2( comp, "mButtonDownFly")
            scroll_up = ComponentGetValue2(comp,"mButtonDownChangeItemL")
            scroll_down = ComponentGetValue2(comp,"mButtonDownChangeItemR")
            local mButtonDownInteract = ComponentGetValue2(comp,"mButtonDownInteract")
            if mButtonDownInteract and ComponentGetValue2(comp,"mButtonFrameInteract") ==GameGetFrameNum() then
                print("interact pressed!")
                interacted = true
            end
        end )
    end

    ------------bolck wand fire
    if fire_enable == false then
        if mouse_x ~= nil then
            if mouse_is_hover_menu(mouse_x,mouse_y,menu_height) == false then
                --clicked,right_clicked =block_fire(mouse_x,mouse_y)
            end
        end
    end

    --update chonsen tribes
    if interacted then
        print("change TRIBES")
        if selected_tribes == TRIBES.hiis then
            selected_tribes = TRIBES.rat
        else
            selected_tribes = TRIBES.hiis
        end
    end        
    
    ------update
    if selected_main_tab_index == 1 then
        local biome = overall_biome_data[selected_biome]
        if biome ~= nil then
            local current_list_lenth = #(biome.content)
            if scroll_down then
                monster_scroll_pos = monster_scroll_pos + 1
            elseif scroll_up then
                monster_scroll_pos = monster_scroll_pos - 1
            end
            monster_scroll_pos = math.max(1, math.min(monster_scroll_pos,current_list_lenth-monster_num_one_page))
            local monster_data = biome.content[selected_monster]
            if monster_data ~= nil then
                local name = monster_data.name
                local sprite = monster_data.sprite.filepath
                local offset_x = monster_data.sprite.offset_x or 0
                local offset_y = monster_data.sprite.offset_y or 0
                if sprite == nil then
                    sprite = "data/entities/projectiles/bomb.xml"--TODO: add a more reasonable sprite
                end

                local scale_x = 1
                if selected_tribes == TRIBES.hiis then
                    scale_x = -1
                end
                GuiOptionsAdd( gui, GUI_OPTION.NonInteractive) 
                GuiImage( gui, current_id,mouse_x/2,mouse_y/2, sprite,1,scale_x,1,0,GUI_RECT_ANIMATION_PLAYBACK.Loop)
                current_id = current_id +1
                GuiOptionsClear( gui)
                if clicked then
                    -- load a preview of monster
                    load_monster_preview(monster_data,selected_tribes)
                end
            end
        end
        --reset menu
        if right_clicked then
            selected_main_tab_index = 1
            selected_biome = 0
            selected_monster = 1
        end
    elseif selected_main_tab_index == 2 then
        --update scroll
        if scroll_down then
            modifier_sub_menu_info.scroll_pos = modifier_sub_menu_info.scroll_pos + 1
        elseif scroll_up then
            modifier_sub_menu_info.scroll_pos = modifier_sub_menu_info.scroll_pos - 1
        end
        modifier_sub_menu_info.scroll_pos = math.max(1, math.min(modifier_sub_menu_info.scroll_pos,#monster_modifier_list -monster_num_one_page))

        if #selected_preview_in_world == 0 then
            --update select logic
            if fire_down then
                --update select range outline
                if click_info.first_click == nil then
                    --first clicked, save the start point of aabb
                    click_info.first_click = {x = mouse_x,y = mouse_y}
                else
                    --draw an outline of aabb
                    --GuiText(gui,mouse_x/2, mouse_y/2,"mouse world pos:"..tostring(mouse_x_world)..","..tostring(mouse_y_world))
                    --GuiText(gui,mouse_x/2, mouse_y/2 + 10,"mouse raw pos:"..tostring(mouse_x)..","..tostring(mouse_y))
                    current_id = draw_select_rectangle(gui,current_id,click_info.first_click.x/2,click_info.first_click.y/2,mouse_x/2,mouse_y/2)
                end
            else
                --mouse released
                if click_info.first_click ~= nil then
                    --select preview entity in aabb
                    for _,previous_entity in pairs(selected_preview_in_world) do
                        EntityRemoveTag(previous_entity,"mod_selected")
                    end
                    local ox,oy = raw_pos_to_world(click_info.first_click.x,click_info.first_click.y)
                    local ex,ey = raw_pos_to_world(mouse_x,mouse_y)
                    local preview_entitites = get_entity_in_rec_with_tag(ox,oy,ex,ey,"mod_monster_preview")
                    selected_preview_in_world = preview_entitites
                    for _,entity in pairs(selected_preview_in_world) do
                        EntityAddTag(entity,"mod_selected")
                    end
                    click_info.first_click = nil
                else
                    --do nothing
                end
            end
        else
            --some preview is selected, update move logic
            GuiOptionsAdd( gui, GUI_OPTION.NonInteractive) 
            GuiImage( gui, current_id+1,mouse_x/2,mouse_y/2, "mods/ArenaForMonster/gfx/move.png",1,0.5,0.5)
            current_id = current_id +1
            GuiOptionsClear( gui)

            if fire_down then
                if click_info.first_click == nil then
                    --first clicked, make selected preview moved with mouse
                    click_info.first_click = {x = mouse_x,y = mouse_y}
                    local mouse_x_world,mouse_y_world = raw_pos_to_world(mouse_x,mouse_y)
                    for _,previous_entity in pairs(selected_preview_in_world) do
                        local entity_x,entity_y = EntityGetTransform(previous_entity)
                        local relative_pos_x = entity_x - mouse_x_world
                        local relative_pos_y = entity_y - mouse_y_world
                        local var_comps = EntityGetComponentIncludingDisabled(previous_entity,"VariableStorageComponent")
                        for _,comp in pairs(var_comps) do
                            if ComponentGetValue2(comp,"name") == "mouse_relative_pos_x" then
                                ComponentSetValue2(comp,"value_float",relative_pos_x)
                            elseif ComponentGetValue2(comp,"name") == "mouse_relative_pos_y" then
                                ComponentSetValue2(comp,"value_float",relative_pos_y)
                            end
                        end
                        EntityAddTag(previous_entity,"mod_drag_by_mouse")
                        EntitySetComponentsWithTagEnabled(previous_entity,"drag_update",true)
                    end
                else
                    --do nothing
                end
            else
                if click_info.first_click ~= nil then
                    --mouse released
                    for _,previous_entity in pairs(selected_preview_in_world) do
                        EntityRemoveTag(previous_entity,"mod_drag_by_mouse")
                        EntitySetComponentsWithTagEnabled(previous_entity,"drag_update",false)
                    end
                    click_info.first_click = nil
                end
            end

        end
        if right_clicked then
            selected_main_tab_index = 2
            for _,previous_entity in pairs(selected_preview_in_world) do
                EntityRemoveTag(previous_entity,"mod_selected")
            end
            selected_preview_in_world = {}
        end
    elseif selected_main_tab_index == 4 then
        --update eraser (and other misc stuff) (if any)
        if selected_misc_tools == "eraser" then
            GuiOptionsAdd( gui, GUI_OPTION.NonInteractive) 
            GuiImage( gui, current_id+1,mouse_x/2,mouse_y/2, "mods/ArenaForMonster/gfx/eraser.png",1,0.5,0.5)
            current_id = current_id +1
            GuiOptionsClear( gui)
            if fire_down then
                local ex,ey = raw_pos_to_world(mouse_x,mouse_y)
                local previews = EntityGetInRadiusWithTag( ex,ey,10, "mod_monster_preview" )
                if previews ~= nil then
                    for _,id in pairs(previews) do
                        EntityKill(id)
                    end
                end
                local enemies = EntityGetInRadiusWithTag(ex,ey,10, "enemy" )
                if enemies ~= nil then
                    for _,id in pairs(enemies) do
                        if id ~= player_id then
                            EntityKill(id)
                        end
                    end
                end 
            end
        end
    end

    return current_id


end
function _monster_arena_update_main()
    --print("Frame start")
    --selected_main_tab_index = 1 
    -------update menu gui 
    local current_id = menu_id_start
    local menu_height = 0
    if  GlobalsGetValue( "MONSTER_ARENA_STATE", "preview" ) == "preview" then
        local current_id,menu_height = update_main_menu(main_menu_x_start,main_menu_y_start,main_menu_width,main_tab)
    end
    ------------update other things when specific tab is selected
    if selected_main_tab_index == 1 then
        --update preview
        local biome_data = overall_biome_data[selected_biome]
        if selected_biome == 0 then
            --do nothing,or update other effect
        elseif biome_data == nil then 
            --update preview animation at a prefixed pos
            print("no biome data of "..tostring(selected_biome))
            local monster_data = biome_data.content[selected_monster]
            local image_file = monster_data.sprite.image_file
            local scale =1
            if monster_data.sprite.offset_x ~= nil then
                scale = math.max(0.2,math.max(monster_data.sprite.offset_x,monster_data.sprite.offset_y)/(line_space/2))
            end
            --GuiImage(gui, current_id + 1, mouse_x,mouse_y,image_file,1,scale)
            current_id = current_id +1
        end
    end

    ----update main button
    update_main_button()
    ------------update player input
    current_id = update_player_input(current_id,menu_height)   

    --GuiText(gui,200,100,"Main index:"..tostring(selected_main_tab_index))
    --GuiText(gui,200,110,"selected biome index:"..tostring(selected_biome))
    --GuiText(gui,200,120,"monster index:"..tostring(selected_monster))
    --GuiText(gui,200,130,"scroll index:"..tostring(monster_scroll_pos))

    if gui ~= nil then
        GuiStartFrame( gui )
    end
    --print("Frame end")
end
