dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )
local radius = 144

local targets = EntityGetInRadiusWithTag( x, y, radius, "mortal" )
local found = false

local gene_comp = EntityGetFirstComponentIncludingDisabled(entity_id,"GenomeDataComponent")
if gene_comp == nil then
    print("no GenomeDataComponent on this robot!")
    return
end  

local herd_id = ComponentGetValue2(gene_comp,"herd_id")

for i,v in ipairs( targets ) do
	if ( EntityHasTag( v, "player_unit" ) == false ) and ( EntityHasTag( v, "necrobot_NOT" ) == false ) then
		
		local gene_comp = EntityGetFirstComponentIncludingDisabled(v,"GenomeDataComponent")
		if gene_comp == nil then
			print("no GenomeDataComponent on this creature!")
		end  
		local creature_herd_id = ComponentGetValue2(gene_comp,"herd_id")

		if creature_herd_id ~= nil and creature_herd_id == herd_id then

			local file = EntityGetFilename( v )
			if ( file ~= nil ) and ( #file > 0 ) and ( string.find( file, "entities/animals/" ) ~= nil ) then
				EntityAddComponent( v, "LuaComponent", 
				{ 
					script_death = "mods/ArenaForMonster/scripts/patch/effects/necrobot_super_death.lua",
					execute_every_n_frame = "-1",
				} )
				
				local eid = EntityLoad( "data/entities/particles/tinyspark_red_sparse.xml", x, y )
				EntityAddChild( v, eid )
			end
		end
		EntityAddTag( v, "necrobot_NOT" )	
	end
end