dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x,y = EntityGetTransform( entity_id )
local comp = EntityGetFirstComponent( entity_id, "VariableStorageComponent", "necrobot_entity_file" )

if ( comp ~= nil ) then
	local file = ComponentGetValue2( comp, "value_string" )
	
	if ( file ~= nil ) and ( #file > 0 ) then
		local eid = EntityLoad( file, x, y )
		EntityLoad( "data/entities/particles/poof_green_sparse.xml", x, y )
		EntityAddComponent( eid, "VariableStorageComponent", 
		{ 
			_tags="no_gold_drop",
		} )

		local var_comps = EntityGetComponentIncludingDisabled(entity_id,"VariableStorageComponent")
		local herd_id 
		for _,comp in pairs(var_comps) do
			if ComponentGetValue2(comp,"name") == "monster_info" then
				herd_id = ComponentGetValue2(comp,"value_int")
				break
			end
		end
		if herd_id ~= nil then
			
			local scripts_entity = EntityLoad("mods/ArenaForMonster/entities/effect_entity/change_herd_id.xml")
			local var_comp = EntityGetFirstComponentIncludingDisabled(scripts_entity,"VariableStorageComponent")
			ComponentSetValue2(var_comp,"value_int",herd_id)
			EntityAddChild(eid,scripts_entity)

			local hp_bar_sprite = "mods/ArenaForMonster/gfx/hp_bar_blue.png"
			if herd_id == StringToHerdId( "rat" ) then
				hp_bar_sprite = "mods/ArenaForMonster/gfx/hp_bar_red.png"
			end
			EntityLoadToEntity("mods/ArenaForMonster/entities/hp_bar.xml", eid )
            local monster_hp_bar_comp = EntityGetFirstComponentIncludingDisabled(eid,"SpriteComponent","hp_bar")
            ComponentSetValue2(monster_hp_bar_comp,"image_file",hp_bar_sprite)
		end


	end
end

EntityKill( entity_id )