dofile("mods/ArenaForMonster/scripts/arena_utili.lua")
dofile("mods/ArenaForMonster/scripts/list/creature_modifier_list.lua")
local is_run = GlobalsGetValue( "MONSTER_ARENA_STATE", "preview" )
TRIBES = {rat=1,hiis =2}

local entity_id = GetUpdatedEntityID()
local modifier ={}
local monster_info = {
    filepath = nil,
    tribes = nil,
    hp = nil,
    hp_is_modified = false,
    modified_hp = nil,
}
monster_info,modifier = get_spawn_info(entity_id)

if EntityHasTag(entity_id,"mod_selected") then
    EntitySetComponentsWithTagEnabled(entity_id,"mark",true)
else
    EntitySetComponentsWithTagEnabled(entity_id,"mark",false)
end


local hp_bar_comp = EntityGetFirstComponentIncludingDisabled(entity_id,"SpriteComponent","hp_bar")
local hp_value_comp = EntityGetFirstComponentIncludingDisabled(entity_id,"SpriteComponent","hp_value")
local hp_value
if monster_info.hp_is_modified then
    hp_value = tostring(math.floor(25* monster_info.modified_hp))
else
    hp_value = tostring(math.floor(25* monster_info.hp))
end
local text_length = string.len(hp_value)
ComponentSetValue2(hp_value_comp,"offset_x",text_length * 2)
ComponentSetValue2(hp_value_comp,"text",hp_value)


if is_run == "combat" then
    local x,y = EntityGetTransform(entity_id)
    if monster_info.filepath == nil then
        print("filepath is nil!")
        return
    end
    print(monster_info.filepath)

    local monster_id = EntityLoad(monster_info.filepath,x,y)
    local herd_id = StringToHerdId( "rat" ) 
    local scale_x = 1

    local hp_bar_sprite ="mods/ArenaForMonster/gfx/hp_bar_red.png"
    if monster_info.tribes == TRIBES.hiis then
        herd_id = StringToHerdId("orcs" ) 
        scale_x = -1
        hp_bar_sprite ="mods/ArenaForMonster/gfx/hp_bar_blue.png"
    end

    local gene_comps = EntityGetComponentIncludingDisabled(monster_id,"GenomeDataComponent")
    if gene_comps == nil then
        EntityRemoveComponent( entity_id,GetUpdatedComponentID())
        print("no GenomeDataComponent!")
        EntityKill( entity_id)
        return
    end

    for _,comp in pairs(gene_comps) do
        ComponentSetValue2(comp,"herd_id",herd_id)
    end 

    local damage_comps = EntityGetComponentIncludingDisabled(monster_id,"DamageModelComponent")
    if damage_comps ~= nil then
        local hp_value
        if monster_info.hp_is_modified then
            hp_value = monster_info.modified_hp
        else
            hp_value = monster_info.hp
        end
        for _,comp in pairs(damage_comps) do
            ComponentSetValue2(comp,"hp",hp_value)
            ComponentSetValue2(comp,"max_hp",hp_value)
        end
    end

    EntityLoadToEntity("mods/ArenaForMonster/entities/hp_bar.xml", monster_id )

    local monster_hp_bar_comp = EntityGetFirstComponentIncludingDisabled(monster_id,"SpriteComponent","hp_bar")
    ComponentSetValue2(monster_hp_bar_comp,"image_file",hp_bar_sprite)

    EntitySetTransform(monster_id,x,y,0,scale_x)
    
    for _,modifier_index in pairs(modifier) do
        if monster_modifier_list[modifier_index] ~= nil then
            monster_modifier_list[modifier_index].func(monster_id)
        end
    end


    EntityKill( entity_id)
end